package rpc

import (
	"fmt"

	"git.loafle.net/commons_go/logging"
	crcwf "git.loafle.net/commons_go/rpc/connection/websocket/fasthttp"
	"git.loafle.net/commons_go/rpc/gateway"
	"git.loafle.net/commons_go/rpc/protocol"
)

type GatewayRPCServletHandlers struct {
	gateway.ServletHandlers
	crcwf.ServletHandlers
}

func (sh *GatewayRPCServletHandlers) Invoke(requestCodec protocol.RegistryCodec) (result interface{}, err error) {
	if !sh.RPCRegistry.HasMethod(requestCodec.Method()) {
		return nil, fmt.Errorf("RPC Servlet Handler: Method[%s] is not exist", requestCodec.Method())
	}

	result, err = sh.RPCRegistry.Invoke(requestCodec)
	if nil != err {

	}

	return
}

func (sh *GatewayRPCServletHandlers) Validate() {
	sh.ServletHandlers.Validate()

	if nil == sh.RPCRegistry {
		logging.Logger().Panic(fmt.Sprintf("RPC Servlet Handler: RPC Registry must be specified"))
	}
}
